package net.mcreator.icespikesbiomeupdate.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.icespikesbiomeupdate.entity.PenguingEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class PenguingRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(PenguingEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("ice_spikes_biome_update:textures/penguing.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.7.5
	// Exported for Minecraft version 1.15
	// Paste this class into your mod and generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer bb_main;
		private final ModelRenderer cube_r1;
		private final ModelRenderer cube_r2;
		public Modelcustom_model() {
			textureWidth = 64;
			textureHeight = 64;
			bb_main = new ModelRenderer(this);
			bb_main.setRotationPoint(0.0F, 24.0F, 0.0F);
			bb_main.setTextureOffset(0, 21).addBox(-3.0F, -1.0F, -1.0F, 3.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 25).addBox(-3.0F, -2.0F, 0.0F, 3.0F, 1.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(24, 20).addBox(-3.0F, -3.0F, 0.0F, 3.0F, 1.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(18, 0).addBox(1.0F, -1.0F, -1.0F, 3.0F, 1.0F, 3.0F, 0.0F, false);
			bb_main.setTextureOffset(24, 24).addBox(1.0F, -2.0F, 0.0F, 3.0F, 1.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(22, 4).addBox(1.0F, -3.0F, 0.0F, 3.0F, 1.0F, 2.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 0).addBox(-3.0F, -10.0F, -1.0F, 7.0F, 8.0F, 4.0F, 0.0F, false);
			bb_main.setTextureOffset(0, 12).addBox(-1.5F, -14.0F, -2.0F, 4.0F, 4.0F, 5.0F, 0.0F, false);
			cube_r1 = new ModelRenderer(this);
			cube_r1.setRotationPoint(-5.0F, -2.0F, -1.0F);
			bb_main.addChild(cube_r1);
			setRotationAngle(cube_r1, 0.0F, 0.0F, 0.3054F);
			cube_r1.setTextureOffset(14, 17).addBox(-1.0F, -8.0F, 0.0F, 1.0F, 8.0F, 4.0F, 0.0F, false);
			cube_r2 = new ModelRenderer(this);
			cube_r2.setRotationPoint(6.5F, -2.25F, -1.0F);
			bb_main.addChild(cube_r2);
			setRotationAngle(cube_r2, 0.0F, 0.0F, -0.2618F);
			cube_r2.setTextureOffset(20, 8).addBox(-1.0F, -8.0F, 0.0F, 1.0F, 8.0F, 4.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			bb_main.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bb_main.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bb_main.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
